| OpenCV 3.4.8 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
cv::aruco::DetectorParameters Struct Reference
ArUco Marker Detection

Parameters for the detectMarker process: More...

`#include <opencv2/aruco.hpp>`

## Public Member Functions
| DetectorParameters ()

## Static Public Member Functions
static Ptr< DetectorParameters > | create ()

## Public Attributes
double | adaptiveThreshConstant
int | adaptiveThreshWinSizeMax
int | adaptiveThreshWinSizeMin
int | adaptiveThreshWinSizeStep
float | aprilTagCriticalRad
int | aprilTagDeglitch
float | aprilTagMaxLineFitMse
int | aprilTagMaxNmaxima
int | aprilTagMinClusterPixels
int | aprilTagMinWhiteBlackDiff
float | aprilTagQuadDecimate
float | aprilTagQuadSigma
int | cornerRefinementMaxIterations
int | cornerRefinementMethod
double | cornerRefinementMinAccuracy
int | cornerRefinementWinSize
bool | detectInvertedMarker
double | errorCorrectionRate
int | markerBorderBits
double | maxErroneousBitsInBorderRate
double | maxMarkerPerimeterRate
double | minCornerDistanceRate
int | minDistanceToBorder
double | minMarkerDistanceRate
double | minMarkerPerimeterRate
double | minOtsuStdDev
double | perspectiveRemoveIgnoredMarginPerCell
int | perspectiveRemovePixelPerCell
double | polygonalApproxAccuracyRate

## Detailed Description

Parameters for the detectMarker process:

- adaptiveThreshWinSizeMin: minimum window size for adaptive thresholding before finding contours (default 3).
- adaptiveThreshWinSizeMax: maximum window size for adaptive thresholding before finding contours (default 23).
- adaptiveThreshWinSizeStep: increments from adaptiveThreshWinSizeMin to adaptiveThreshWinSizeMax during the thresholding (default 10).
- adaptiveThreshConstant: constant for adaptive thresholding before finding contours (default 7)
- minMarkerPerimeterRate: determine minimum perimeter for marker contour to be detected. This is defined as a rate respect to the maximum dimension of the input image (default 0.03).
- maxMarkerPerimeterRate: determine maximum perimeter for marker contour to be detected. This is defined as a rate respect to the maximum dimension of the input image (default 4.0).
- polygonalApproxAccuracyRate: minimum accuracy during the polygonal approximation process to determine which contours are squares.
- minCornerDistanceRate: minimum distance between corners for detected markers relative to its perimeter (default 0.05)
- minDistanceToBorder: minimum distance of any corner to the image border for detected markers (in pixels) (default 3)
- minMarkerDistanceRate: minimum mean distance beetween two marker corners to be considered similar, so that the smaller one is removed. The rate is relative to the smaller perimeter of the two markers (default 0.05).
- cornerRefinementMethod: corner refinement method. (CORNER_REFINE_NONE, no refinement. CORNER_REFINE_SUBPIX, do subpixel refinement. CORNER_REFINE_CONTOUR use contour-Points, CORNER_REFINE_APRILTAG use the AprilTag2 approach)
- cornerRefinementWinSize: window size for the corner refinement process (in pixels) (default 5).
- cornerRefinementMaxIterations: maximum number of iterations for stop criteria of the corner refinement process (default 30).
- cornerRefinementMinAccuracy: minimum error for the stop cristeria of the corner refinement process (default: 0.1)
- markerBorderBits: number of bits of the marker border, i.e. marker border width (default 1).
- perspectiveRemovePixelPerCell: number of bits (per dimension) for each cell of the marker when removing the perspective (default 8).
- perspectiveRemoveIgnoredMarginPerCell: width of the margin of pixels on each cell not considered for the determination of the cell bit. Represents the rate respect to the total size of the cell, i.e. perspectiveRemovePixelPerCell (default 0.13)
- maxErroneousBitsInBorderRate: maximum number of accepted erroneous bits in the border (i.e. number of allowed white bits in the border). Represented as a rate respect to the total number of bits per marker (default 0.35).
- minOtsuStdDev: minimun standard deviation in pixels values during the decodification step to apply Otsu thresholding (otherwise, all the bits are set to 0 or 1 depending on mean higher than 128 or not) (default 5.0)
- errorCorrectionRate error correction rate respect to the maximun error correction capability for each dictionary. (default 0.6).
- aprilTagMinClusterPixels: reject quads containing too few pixels.
- aprilTagMaxNmaxima: how many corner candidates to consider when segmenting a group of pixels into a quad.
- aprilTagCriticalRad: Reject quads where pairs of edges have angles that are close to straight or close to 180 degrees. Zero means that no quads are rejected. (In radians).
- aprilTagMaxLineFitMse: When fitting lines to the contours, what is the maximum mean squared error allowed? This is useful in rejecting contours that are far from being quad shaped; rejecting these quads "early" saves expensive decoding processing.
- aprilTagMinWhiteBlackDiff: When we build our model of black & white pixels, we add an extra check that the white model must be (overall) brighter than the black model. How much brighter? (in pixel values, [0,255]).
- aprilTagDeglitch: should the thresholded image be deglitched? Only useful for very noisy images
- aprilTagQuadDecimate: Detection of quads can be done on a lower-resolution image, improving speed at a cost of pose accuracy and a slight decrease in detection rate. Decoding the binary payload is still done at full resolution.
- aprilTagQuadSigma: What Gaussian blur should be applied to the segmented image (used for quad detection?) Parameter is the standard deviation in pixels. Very noisy images benefit from non-zero values (e.g. 0.8).
- detectInvertedMarker: to check if there is a white marker. In order to generate a "white" marker just invert a normal marker by using a tilde, ~markerImage. (default false)

## Constructor & Destructor Documentation

## § DetectorParameters()

cv::aruco::DetectorParameters::DetectorParameters | ( |  | ) |

## Member Function Documentation

## § create()

static Ptr<DetectorParameters> cv::aruco::DetectorParameters::create | ( |  | ) |
| static

## Member Data Documentation

## § adaptiveThreshConstant

double cv::aruco::DetectorParameters::adaptiveThreshConstant

## § adaptiveThreshWinSizeMax

int cv::aruco::DetectorParameters::adaptiveThreshWinSizeMax

## § adaptiveThreshWinSizeMin

int cv::aruco::DetectorParameters::adaptiveThreshWinSizeMin

## § adaptiveThreshWinSizeStep

int cv::aruco::DetectorParameters::adaptiveThreshWinSizeStep

## § aprilTagCriticalRad

float cv::aruco::DetectorParameters::aprilTagCriticalRad

## § aprilTagDeglitch

int cv::aruco::DetectorParameters::aprilTagDeglitch

## § aprilTagMaxLineFitMse

float cv::aruco::DetectorParameters::aprilTagMaxLineFitMse

## § aprilTagMaxNmaxima

int cv::aruco::DetectorParameters::aprilTagMaxNmaxima

## § aprilTagMinClusterPixels

int cv::aruco::DetectorParameters::aprilTagMinClusterPixels

## § aprilTagMinWhiteBlackDiff

int cv::aruco::DetectorParameters::aprilTagMinWhiteBlackDiff

## § aprilTagQuadDecimate

float cv::aruco::DetectorParameters::aprilTagQuadDecimate

## § aprilTagQuadSigma

float cv::aruco::DetectorParameters::aprilTagQuadSigma

## § cornerRefinementMaxIterations

int cv::aruco::DetectorParameters::cornerRefinementMaxIterations

## § cornerRefinementMethod

int cv::aruco::DetectorParameters::cornerRefinementMethod

## § cornerRefinementMinAccuracy

double cv::aruco::DetectorParameters::cornerRefinementMinAccuracy

## § cornerRefinementWinSize

int cv::aruco::DetectorParameters::cornerRefinementWinSize

## § detectInvertedMarker

bool cv::aruco::DetectorParameters::detectInvertedMarker

## § errorCorrectionRate

double cv::aruco::DetectorParameters::errorCorrectionRate

## § markerBorderBits

int cv::aruco::DetectorParameters::markerBorderBits

## § maxErroneousBitsInBorderRate

double cv::aruco::DetectorParameters::maxErroneousBitsInBorderRate

## § maxMarkerPerimeterRate

double cv::aruco::DetectorParameters::maxMarkerPerimeterRate

## § minCornerDistanceRate

double cv::aruco::DetectorParameters::minCornerDistanceRate

## § minDistanceToBorder

int cv::aruco::DetectorParameters::minDistanceToBorder

## § minMarkerDistanceRate

double cv::aruco::DetectorParameters::minMarkerDistanceRate

## § minMarkerPerimeterRate

double cv::aruco::DetectorParameters::minMarkerPerimeterRate

## § minOtsuStdDev

double cv::aruco::DetectorParameters::minOtsuStdDev

## § perspectiveRemoveIgnoredMarginPerCell

double cv::aruco::DetectorParameters::perspectiveRemoveIgnoredMarginPerCell

## § perspectiveRemovePixelPerCell

int cv::aruco::DetectorParameters::perspectiveRemovePixelPerCell

## § polygonalApproxAccuracyRate

double cv::aruco::DetectorParameters::polygonalApproxAccuracyRate

The documentation for this struct was generated from the following file:

- opencv2/aruco.hpp